# Swagger / OpenAPI 3.0

Best docs are here: [Documentation](https://swagger.io/docs/specification/about/).

# Filesystem layout

```
types/
 | -> one .yml file per type, using $ref to chain them
schemas/
 | -> one .yml file per schema, using $ref to chain them
endpoints/
 | -> all endpoints
/api.yml -> file linking in all endpoints
```

# Validate files
```bash
swagger-cli validate api.yml
```

# Bundle into one file
```bash
swagger-cli bundle api.yml > api_all.json
```

# Start a webserver to preview
```bash
npx redoc-cli serve --watch --port 9090 api.yml
```

You need to manually reload the browser after changes.