// Generated by CoffeeScript 1.12.7
var ez5;

ez5 = (function() {
  function ez5() {}

  ez5.FRONTEND_VERSION = "5.114.0";

  ez5.cssLoader = new CUI.CSSLoader();

  ez5.handleFrontendError = function(errorEvent, show_to_user) {
    var show_msg;
    if (show_to_user == null) {
      show_to_user = false;
    }
    show_msg = (function(_this) {
      return function(event) {
        var event_id, loca_key, ref;
        event_id = event != null ? (ref = event.event) != null ? ref._id : void 0 : void 0;
        if (event_id) {
          loca_key = 'general.frontend.error.message_with_id.md';
        } else {
          loca_key = 'general.frontend.error.message.md';
        }
        return CUI.confirm({
          "class": 'cui-alert-problem',
          text: $$(loca_key, {
            event_id: event_id
          }),
          button_text_ok: $$('general.frontend.error.button.ok'),
          button_text_cancel: $$('general.frontend.error.button.reload'),
          markdown: true
        }).fail(function() {
          return document.location.reload();
        });
      };
    })(this);
    return this.saveErrorEvent(errorEvent).always((function(_this) {
      return function(event) {
        if (show_to_user) {
          return show_msg(event);
        }
      };
    })(this));
  };

  ez5.saveErrorEvent = function(errorEvent) {
    var ref, ref1;
    return EventPoller.saveEvent({
      type: "FRONTEND_ERROR",
      info: {
        message: ((ref = errorEvent.error) != null ? ref.message : void 0) || errorEvent.message,
        navigator: navigator.userAgent,
        stack: (ref1 = errorEvent.error) != null ? ref1.stack : void 0
      }
    });
  };

  ez5.version = function(exp_version) {
    var idx, j, len1, part_exp, parts_exp, parts_v, ref, ref1, v;
    v = ((ref = ez5.settings) != null ? ref.version : void 0) || null;
    if (v) {
      v = v.replace(/^v/, "");
    } else {
      v = ((ref1 = ez5.settings) != null ? ref1.easydb_version : void 0) || null;
    }
    if (CUI.util.isEmpty(exp_version)) {
      return v;
    }
    if (v === null) {
      return false;
    }
    parts_v = v.split(".").map((function(_this) {
      return function(v) {
        return parseInt(v);
      };
    })(this));
    parts_exp = exp_version.split(".").map((function(_this) {
      return function(v) {
        return parseInt(v);
      };
    })(this));
    for (idx = j = 0, len1 = parts_exp.length; j < len1; idx = ++j) {
      part_exp = parts_exp[idx];
      if (parts_v[idx] > part_exp) {
        return true;
      }
      if (part_exp > parts_v[idx]) {
        return false;
      }
    }
    return true;
  };

  ez5.callbacks = {};

  ez5.state = "loading";

  ez5.fitRectangle = function(img_w, img_h, w, h) {
    var dest_h, dest_w, img_aspect, margin_left, margin_top, viewport_aspect;
    CUI.util.assert(img_w > 0 && img_h > 0 && w > 0 && h > 0, "ez5.fit_rectangle", "img_w, img_h, w and h need to be > 0", {
      img_w: img_w,
      img_h: img_h,
      w: w,
      h: h
    });
    img_aspect = img_w / img_h;
    viewport_aspect = w / h;
    if (img_aspect > viewport_aspect) {
      dest_w = w;
      dest_h = dest_w / img_aspect;
    } else if (img_aspect < viewport_aspect) {
      dest_h = h;
      dest_w = dest_h * img_aspect;
    } else {
      dest_w = w;
      dest_h = h;
    }
    margin_top = (h - dest_h) / 2;
    margin_left = (w - dest_w) / 2;
    return [dest_w, dest_h, margin_top, margin_left];
  };

  ez5.format_seconds = function(seconds) {
    var h, m, s;
    if (seconds === 2e308) {
      return "--:--";
    }
    h = Math.floor(seconds / 3600);
    m = Math.floor((seconds - h * 3600) / 60);
    s = Math.ceil(seconds - h * 3600 - m * 60);
    if (s < 10) {
      s = "0" + s;
    }
    if (h > 0 && m < 10) {
      m = "0" + m;
    }
    if (h > 0) {
      return h + ":" + m + ":" + s;
    } else {
      return m + ":" + s;
    }
  };

  ez5.format_date_and_time = function(date_s, include_seconds) {
    var mom;
    if (include_seconds == null) {
      include_seconds = false;
    }
    if (CUI.util.isEmpty(date_s)) {
      return "";
    }
    if (date_s instanceof Date) {
      mom = CUI.util.moment(date_s);
      date_s = mom.format(CUI.DateTimeFormats[ez5.loca.getLanguage()].formats.display_short);
    }
    if (include_seconds) {
      return CUI.DateTime.format(date_s, "display_short", "date_time_seconds");
    } else {
      return CUI.DateTime.format(date_s, "display_short", "date_time");
    }
  };

  ez5.format_date = function(date_s) {
    return CUI.DateTime.format(date_s, "display_short", "date");
  };

  ez5.dirname = function(path) {
    var _path;
    if (CUI.util.isEmpty(path)) {
      return "";
    }
    _path = path.split(/[\/]/);
    _path.pop();
    switch (_path.length) {
      case 0:
        return '';
      case 1:
        if (_path[0] === '') {
          return '/';
        }
    }
    return _path.join('/');
  };

  ez5.basename = function(path) {
    if (CUI.util.isEmpty(path)) {
      return "";
    }
    return path.split(/[\/]/).pop();
  };

  ez5.extension = function(path) {
    var _path, basename;
    basename = this.basename(path);
    if (CUI.util.isEmpty(basename)) {
      return '';
    }
    _path = basename.split(/\./);
    if (_path.length > 1) {
      return _path.pop();
    } else {
      return '';
    }
  };

  ez5.bareBasename = function(path) {
    var _path, basename;
    basename = this.basename(path);
    if (CUI.util.isEmpty(basename)) {
      return '';
    }
    _path = basename.split(/\./);
    if (_path.length > 1) {
      _path.pop();
    }
    return _path.join('.');
  };

  ez5.getAbsoluteURL = function(url, server_url) {
    var loc;
    if (server_url == null) {
      server_url = window.easydb_server_url;
    }
    loc = CUI.parseLocation(url);
    if (!loc) {
      return "";
    } else if (loc.origin) {
      return url;
    } else if (server_url) {
      return server_url + url;
    } else {
      return document.location.origin + url;
    }
  };

  ez5.format_number = function(number) {
    if (CUI.util.isEmpty(number)) {
      return "";
    }
    if (typeof number === "number") {
      return CUI.NumberInput.format(number, {
        decimalpoint: ez5.session.frontend_locale.numbers.decimal,
        separator: ez5.session.frontend_locale.numbers.grouping
      });
    } else {
      return number;
    }
  };

  ez5.format_bitrate = function(bits) {
    var gBits, kBits, mBits;
    if (typeof bits !== 'number') {
      return '';
    }
    if (bits >= 1000000000) {
      gBits = (bits / 1000000000).toFixed(2);
      return gBits + " Gbit/s";
    } else if (bits >= 1000000) {
      mBits = (bits / 1000000).toFixed(2);
      return mBits + " Mbit/s";
    } else if (bits >= 1000) {
      kBits = (bits / 1000).toFixed(2);
      return kBits + " kbit/s";
    } else {
      return (bits.toFixed(2)) + " bit/s";
    }
  };

  ez5.download_multiple_files = function(files, fylr_zip_url, zip_download_name) {
    var _files, file, form, j, json, len1;
    _files = [];
    for (j = 0, len1 = files.length; j < len1; j++) {
      file = files[j];
      _files.push({
        url: file.href,
        name: decodeURIComponent(ez5.basename(file.href))
      });
    }
    form = document.createElement("form");
    form.action = fylr_zip_url;
    form.target = '_parent';
    form.method = "POST";
    json = document.createElement("input");
    json.type = "hidden";
    json.name = "BODY";
    json.value = JSON.stringify({
      filename: zip_download_name + ".zip",
      files: _files
    });
    form.appendChild(json);
    document.body.appendChild(form);
    return form.submit();
  };

  ez5.download_files = function(files) {
    CUI.util.assert(CUI.util.isArray(files), "ez5.download_files", "Parameter 'files' needs to be an array", {
      files: files
    });
    return CUI.chunkWork.call(ez5, {
      items: files,
      chunk_size: 1,
      call: function(items) {
        var deferred;
        deferred = new CUI.Deferred();
        ez5.download_file(items[0]);
        CUI.setTimeout({
          ms: 3000,
          call: function() {
            return deferred.resolve();
          }
        });
        return deferred.promise();
      }
    });
  };

  ez5.download_file = function(file) {
    var a;
    a = CUI.dom.element("A");
    a.href = file.href;
    a.download = "";
    a.target = '_parent';
    (document.body || document.documentElement).appendChild(a);
    a.addEventListener("click", function() {
      return CUI.dom.remove(a);
    });
    return a.click();
  };

  ez5.format_filesize = function(bytes) {
    var base, i, sizes;
    if (isNaN(bytes)) {
      return "";
    }
    sizes = ["Bytes", "KB", "MB", "GB", "TB"];
    base = 1024;
    i = parseInt(Math.floor(Math.log(bytes) / Math.log(base)));
    if (bytes === 0) {
      return "0 " + sizes[0];
    } else if (i <= 1) {
      return Math.round(bytes / Math.pow(base, i)) + " " + sizes[i];
    } else {
      return Math.round(bytes / Math.pow(base, i) * 10) / 10 + " " + sizes[i];
    }
  };

  ez5.buildObjectTree = function(_opts) {
    var __path, _object, _path, c, doOpen, fatherPool, idx, inputObjects, j, l, len1, len2, len3, len4, len5, len6, len7, level, max_level, n, newInstanceFunc, o, obj, object, objectCopy, objectIdKey, objectKey, object_by_path, objects, objecttype, opts, p, path, path_str, pseudoRoot, q, ref, ref1, ref2, ref3, ref4, t, u, x, y;
    if (_opts == null) {
      _opts = {};
    }
    opts = CUI.Element.readOpts.call(this, _opts, "ez5.buildObjectTree", {
      objects: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isArray(v);
        }
      },
      newInstanceFunc: {
        mandatory: true,
        check: Function
      },
      doOpen: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      filter: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      objectKey: {
        check: function(v) {
          return CUI.util.isString(v) || CUI.util.isFunction(v);
        }
      }
    });
    objectKey = opts.objectKey;
    newInstanceFunc = opts.newInstanceFunc;
    doOpen = opts.doOpen;
    objectIdKey = "_id";
    inputObjects = [];
    ref = opts.objects;
    for (j = 0, len1 = ref.length; j < len1; j++) {
      _object = ref[j];
      if (_object.hasOwnProperty("_path")) {
        _object.__path = _object._path;
        inputObjects.push(_object);
      } else if (_object.hasOwnProperty("_paths")) {
        if (_object._paths.length === 0) {
          objectCopy = CUI.util.copyObject(_object, true);
          objectCopy.__path = [objectCopy];
          inputObjects.push(objectCopy);
        } else {
          ref1 = _object._paths;
          for (l = 0, len2 = ref1.length; l < len2; l++) {
            __path = ref1[l];
            objectCopy = CUI.util.copyObject(_object, true);
            objectCopy.__path = CUI.util.copyObject(__path, true);
            objectCopy.__path.push(objectCopy);
            inputObjects.push(objectCopy);
          }
        }
      } else {
        inputObjects.push(_object);
      }
    }
    object_by_path = {};
    objects = [];
    max_level = -1;
    for (idx = n = 0, len3 = inputObjects.length; n < len3; idx = ++n) {
      o = inputObjects[idx];
      if (o._level === void 0) {
        if (o.hasOwnProperty("__path")) {
          o._level = o.__path.length;
        } else {
          o._level = 0;
        }
      }
      if (o._level > max_level) {
        max_level = o._level;
      }
    }
    for (level = q = 0, ref2 = max_level; q <= ref2; level = q += 1) {
      for (idx = t = 0, len4 = inputObjects.length; t < len4; idx = ++t) {
        o = inputObjects[idx];
        if (o._level !== level) {
          continue;
        }
        objecttype = o._basetype || o._objecttype;
        path = [objecttype];
        if (o.hasOwnProperty("__path")) {
          _path = o.__path;
        } else {
          _path = [o];
        }
        for (idx = u = 0, len5 = _path.length; u < len5; idx = ++u) {
          object = _path[idx];
          if (objectKey) {
            if (CUI.util.isFunction(objectKey)) {
              p = object[objectKey(object)][objectIdKey];
            } else {
              p = object[objectKey][objectIdKey];
            }
          } else {
            p = object[objectIdKey];
          }
          CUI.util.assert(!CUI.util.isEmpty(p), "ez5.buildObjectTree", "path element is empty", {
            objectKey: objectKey,
            objectIdKey: objectIdKey,
            object: object
          });
          path.push(p);
          path_str = path.join(".");
          if (object_by_path[path_str]) {
            continue;
          }
          if (idx === _path.length - 1) {
            obj = newInstanceFunc(o);
          } else {
            obj = newInstanceFunc(object);
            obj._build_from_path = true;
          }
          object_by_path[path_str] = obj;
          if (idx === 0) {
            objects.push(obj);
            continue;
          }
          fatherPool = object_by_path[path.slice(0, -1).join(".")];
          if (!fatherPool.children) {
            fatherPool.children = [];
            if (doOpen) {
              fatherPool.do_open = true;
            }
          }
          obj.father = fatherPool;
          fatherPool.children.push(obj);
        }
      }
    }
    if (opts.filter) {
      pseudoRoot = new CUI.ListViewTreeNode({
        children: objects
      });
      pseudoRoot.filter(function(node) {
        if (node._build_from_path) {
          return true;
        } else {
          return false;
        }
      });
      objects = [];
      ref3 = pseudoRoot.children;
      for (x = 0, len6 = ref3.length; x < len6; x++) {
        c = ref3[x];
        if (!((ref4 = c.children) != null ? ref4.length : void 0)) {
          delete c.do_open;
        }
        objects.push(c);
        c.setFather(null);
      }
    }
    for (y = 0, len7 = inputObjects.length; y < len7; y++) {
      _object = inputObjects[y];
      delete _object.__path;
      delete _object._level;
    }
    return objects;
  };

  ez5.groupTreeNodes = function(_opts) {
    var count, depth, generate_chunks, limit, nodes, opts;
    if (_opts == null) {
      _opts = {};
    }
    opts = CUI.Element.readOpts.call(this, _opts, "ez5.buildObjectTree", {
      newInstanceFunc: {
        mandatory: true,
        check: Function
      },
      limit: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isPosInt(v);
        }
      },
      nodes: {
        mandatory: true,
        check: function(v) {
          var father, idx, item, j, len1;
          if (!CUI.util.isArray(v)) {
            return false;
          }
          father = null;
          for (idx = j = 0, len1 = v.length; j < len1; idx = ++j) {
            item = v[idx];
            if (!(item instanceof CUI.ListViewTreeNode)) {
              return false;
            }
            if (idx === 0) {
              father = item.getFather();
            } else if (father !== item.getFather()) {
              return false;
            }
          }
          return true;
        }
      }
    });
    nodes = opts.nodes;
    count = nodes.length;
    limit = opts.limit;
    if (count <= limit) {
      return nodes;
    }
    depth = 0;
    while (count > Math.pow(limit, depth)) {
      depth = depth + 1;
    }
    generate_chunks = (function(_this) {
      return function(offset, count, depth, father_node) {
        var chunk, from, group_nodes, idx, j, node, ref, to;
        chunk = Math.pow(limit, depth - 1);
        group_nodes = [];
        for (idx = j = 0, ref = Math.floor((count - 1) / chunk); 0 <= ref ? j <= ref : j >= ref; idx = 0 <= ref ? ++j : --j) {
          from = idx * chunk + offset;
          to = Math.min(count, (idx + 1) * chunk) + offset - 1;
          node = opts.newInstanceFunc(from, to, nodes);
          group_nodes.push(node);
          if (depth > 2) {
            generate_chunks(from, to - from + 1, depth - 1, node);
          } else {
            node.setChildren(nodes.slice(from, to + 1));
          }
        }
        if (father_node != null) {
          father_node.setChildren(group_nodes);
        }
        return group_nodes;
      };
    })(this);
    return generate_chunks(0, count, depth);
  };

  ez5.error_handler = function(xhr, serverRequest) {
    var allow_cancel, choices, content, description, dfr, error, markdown, offer_reload, ref, ref1, ref2, ref3, server, server_url, text, title, uuid;
    if (xhr == null) {
      xhr = {};
    }
    if (serverRequest == null) {
      serverRequest = null;
    }
    dfr = new CUI.Deferred();
    error = xhr.responseJSON;
    allow_cancel = true;
    if (serverRequest) {
      server_url = serverRequest.getServerUrl();
      if (server_url === document.location.origin) {
        server_url = null;
      }
    } else {
      server_url = window.easydb_server_url;
    }
    console.warn("ez5.error_handler", xhr.readyState, xhr.status, error, xhr.CUI_statusText);
    if (xhr.readyState < 4 || !((error != null ? error.code : void 0) && (error != null ? error.realm : void 0))) {
      server = server_url || document.location.origin;
      offer_reload = true;
      if (xhr.status === 500) {
        text = $$("base.error.generic", {
          server: server
        });
        allow_cancel = false;
      } else if (xhr.CUI_statusText === "timeout") {
        text = $$("base.error.timeout", {
          server: server
        });
        offer_reload = false;
      } else if (xhr.readyState < 4 || xhr.status === 0) {
        text = $$("base.error.network", {
          server: server
        });
        allow_cancel = false;
      } else {
        console.error("easydb-server returned an unparsable error. xhr: ", xhr);
        text = $$("base.error.generic", {
          server: server
        });
      }
      markdown = true;
      choices = [
        offer_reload && server_url ? {
          text: $$("ez5.error_handler.reset_server", {
            server: server
          }),
          tooltip: {
            text: server
          },
          choice: "reset_server"
        } : void 0, offer_reload ? {
          text: $$("base.reload", {
            server: server
          }),
          choice: "reload"
        } : void 0, {
          text: $$("base.retry", {
            server: server
          }),
          choice: "retry"
        }
      ];
    } else {
      choices = [];
      title = $$("base.error.realm." + error.realm);
      if (ez5.loca.has(error.code)) {
        text = $$(error.code, error.parameters);
        markdown = true;
      } else {
        text = error.error || error.code;
        markdown = false;
      }
      allow_cancel = false;
      if ((ref = error.realm) === "api" || ref === "server") {
        description = error.description;
      }
      if (((ref1 = error.realm) === "server") && error.uuid) {
        uuid = $$("base.error.uuid", {
          uuid: error.uuid
        });
      }
      if (uuid && ((ref2 = ez5.session) != null ? ref2.hasSystemRight("root", "server.error.uuid_detail", "server.error.self_uuid_detail") : void 0)) {
        choices = [
          {
            text: $$("base.error.uuid.modal.btn"),
            choice: "show_error"
          }, {
            text: $$("base.ok"),
            primary: true
          }
        ];
      } else if ((ref3 = error.realm) === "user") {
        return CUI.problem({
          text: text
        });
      }
    }
    content = new CUI.Template({
      name: "error",
      map: {
        text: true,
        description: true,
        uuid: true
      }
    });
    content.replace(new CUI.Label({
      multiline: true,
      text: text,
      markdown: markdown
    }), "text");
    if (description) {
      content.replace(new CUI.Label({
        multiline: true,
        text: description
      }), "description");
    }
    if (uuid) {
      content.replace(new CUI.Label({
        multiline: true,
        text: uuid
      }), "uuid");
    }
    CUI.problem({
      title: title,
      choices: choices.length > 0 ? choices : void 0,
      content: content,
      cancel: allow_cancel
    }).fail(dfr.resolve).done((function(_this) {
      return function(choice) {
        var ref4;
        switch (choice.choice) {
          case "reload":
            document.location.reload();
            break;
          case "reset_server":
            CUI.setSessionStorage("server", void 0);
            if ((ref4 = ez5.session) != null) {
              ref4.saveCookiePref("easydb_server_url", null);
            }
            document.location.assign(window.easydb_base_prefix + "/");
            break;
          case "retry":
            dfr.reject();
            return;
          case "show_error":
            (new ServerErrorModal(error)).show();
        }
        return dfr.resolve();
      };
    })(this));
    return dfr.promise();
  };

  ez5.renderFormPopoverInfo = function(info) {
    var div, inf, j, len1;
    if (!(info != null ? info.length : void 0)) {
      return;
    }
    div = CUI.dom.div("ez5-form-popover-info");
    for (j = 0, len1 = info.length; j < len1; j++) {
      inf = info[j];
      div.appendChild(new CUI.Label({
        "class": "ez5-form-popover-info-item",
        text: inf
      }).DOM);
    }
    return div;
  };

  ez5.replaceMap = function(_value, rec, repl_default) {
    var k, map, map2, match, re, v, value;
    if (repl_default == null) {
      repl_default = "";
    }
    value = _value;
    map = {};
    re = new RegExp("%([\-\._\:a-z0-9]+)%", "g");
    while (match = re.exec(value)) {
      map[match[0]] = repl_default;
    }
    if (!CUI.util.isEmptyObject(map)) {
      map2 = {};
      for (k in rec) {
        v = rec[k];
        if (CUI.util.isArray(v)) {
          map2["%" + k + "%"] = v.join(", ");
        } else {
          map2["%" + k + "%"] = v;
        }
      }
      value = CUI.util.stringMapReplace(value, map2);
      value = CUI.util.stringMapReplace(value, map);
      console.error("REPLACED:", _value, value, map, map2);
    }
    return value;
  };

  ez5.weekdays = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];

  ez5.generateUUID = function() {
    var d;
    d = Date.now();
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
      var r;
      r = (d + Math.random() * 16) % 16 | 0;
      d = Math.floor(d / 16);
      return (c === 'x' ? r : r & 0x3 | 0x8).toString(16);
    });
  };

  ez5.setDefaults = function() {
    ez5.defaults = {
      focusClass: "ez-focus",
      "class": {
        User: User,
        Group: Group,
        SystemGroup: SystemGroup,
        CustomGroup: CustomGroup,
        AnonymousUser: AnonymousUser,
        SystemUser: SystemUser,
        CollectionWorkfolder: CollectionWorkfolder,
        SearchCollection: SearchCollection,
        DownloadManager: DownloadManager,
        AdminMessage: AdminMessage,
        WebDVDPlayer: WebDVDPlayer
      }
    };
    return ez5.getLabelForCount = function(loca_key, count) {
      switch (count) {
        case 0:
          return new CUI.EmptyLabel({
            text: $$(loca_key + ".none", {
              count: count
            })
          });
        case 1:
          return new CUI.Label({
            text: $$(loca_key + ".one", {
              count: count
            })
          });
        default:
          return new CUI.Label({
            text: $$(loca_key, {
              count: count
            })
          });
      }
    };
  };

  ez5.add_ellipsis = function(str, len) {
    var chars;
    if (str.length <= len) {
      return str;
    }
    chars = str.split("");
    chars.splice(len / 2, str.length - len, "…");
    return chars.join("");
  };

  ez5.chunked_work = function(items, chunk_size, func) {
    var dfr, idx, len, next_chunk;
    CUI.util.assert(this !== ez5, "ez5.chunked_work", "Cannot call ez5.chunked_work with 'this' not set to the caller.");
    dfr = new CUI.Deferred();
    idx = 0;
    len = items.length;
    next_chunk = (function(_this) {
      return function() {
        var progress;
        progress = (idx + 1) + " - " + Math.min(len, idx + chunk_size) + " / " + len;
        dfr.notify({
          progress: progress,
          idx: idx,
          len: len,
          chunk_size: chunk_size
        });
        return func.call(_this, items.slice(idx, idx + chunk_size)).fail(dfr.reject).done(function() {
          if (idx + chunk_size >= len) {
            return dfr.resolve();
          } else {
            idx = idx + chunk_size;
            return CUI.setTimeout({
              ms: 10,
              call: next_chunk
            });
          }
        });
      };
    })(this);
    CUI.setTimeout({
      ms: 10,
      call: next_chunk
    });
    return dfr.promise();
  };

  ez5.splash = {
    show: function(loca_key, loca_key_attrs) {
      var ref;
      if ((ref = ez5.splash.__toaster) != null) {
        ref.destroy();
      }
      return ez5.splash.__toaster = CUI.toaster({
        show_ms: 0,
        content: new LocaLabel({
          loca_key: loca_key,
          loca_key_attrs: loca_key_attrs,
          ui: loca_key
        })
      });
    },
    done: function(loca_key, loca_key_attrs) {
      if (!ez5.splash.__toaster) {
        return;
      }
      if (loca_key) {
        ez5.splash.__toaster.setContent(new LocaLabel({
          loca_key: loca_key,
          loca_key_attrs: loca_key_attrs,
          ui: loca_key
        }));
      }
      return CUI.setTimeout({
        ms: 1000,
        call: function() {
          return ez5.splash.hide();
        }
      });
    },
    hide: function() {
      var ref;
      if ((ref = ez5.splash.__toaster) != null) {
        ref.destroy();
      }
      return ez5.splash.__toaster = null;
    }
  };

  return ez5;

})();

(function() {
  var fn, index_version, j, k, len1, ref, ref1;
  index_version = ((ref = document.getElementById("index-version")) != null ? ref.getAttribute("data-version") : void 0) || "1";
  if (index_version !== "2") {
    if (window.sessionStorage.getItem("index-version") === index_version) {
      console.warn("Accepting too old index.html after reload.");
    } else {
      console.warn("Reloading too old index.html.");
      try {
        window.sessionStorage.setItem("index-version", index_version);
        document.location.reload();
      } catch (error1) {}
    }
  } else {
    console.info("Index version is current.");
  }
  ref1 = ["session_ready", "defaults_done", "load_defaults"];
  fn = function(k) {
    return ez5[k] = function(callback) {
      var announceError, cb, e, l, len2, prm, promises, ref2;
      if (callback == null) {
        callback = null;
      }
      if (callback === null) {
        console.timeLog("Start", k + "...");
        promises = [];
        announceError = false;
        ref2 = ez5.callbacks[k];
        for (l = 0, len2 = ref2.length; l < len2; l++) {
          cb = ref2[l];
          try {
            prm = cb();
            if (CUI.util.isPromise(prm)) {
              console.timeLog("Start", "promise during " + k);
              prm.always((function(_this) {
                return function() {
                  return console.timeLog("Start", "promise done " + k);
                };
              })(this));
              prm.fail((function(_this) {
                return function() {
                  return console.warn(k, "was rejected");
                };
              })(this));
              promises.push(prm);
            }
          } catch (error1) {
            e = error1;
            announceError = true;
            console.error(k, "threw exception", e);
          }
        }
        if (announceError) {
          promises.push(CUI.problem({
            text: $$("start.error.unexpected")
          }));
        }
        return CUI.whenAll(promises).always(function() {
          return console.timeLog("Start", k + " done");
        });
      }
      CUI.util.assert(callback instanceof Function, "ez5." + k, "Parameter needs to be Function", {
        callback: callback
      });
      return ez5.callbacks[k].push(callback);
    };
  };
  for (j = 0, len1 = ref1.length; j < len1; j++) {
    k = ref1[j];
    ez5.callbacks[k] = [];
    fn(k);
  }
})();

CUI.ready((function(_this) {
  return function() {
    var renderer;
    renderer = new CUI.util.marked.Renderer();
    renderer.link = function(href, title, text) {
      var a_node;
      a_node = CUI.dom.element("A", {
        target: "_blank",
        href: href,
        title: title
      });
      a_node.innerHTML = text;
      return a_node.outerHTML;
    };
    CUI.defaults.marked_opts.renderer = renderer;
    CUI.defaults.asserts_alert = 'off';
    return CUI.Events.listen({
      node: window,
      type: 'error',
      call: function(ev) {
        ez5.handleFrontendError(ev.getNativeEvent(), ez5.session.isDebug() || CUI.__in_error);
      }
    });
  };
})(this));
// Generated by CoffeeScript 1.12.7
var ServerRequest,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

ServerRequest = (function(superClass) {
  extend(ServerRequest, superClass);

  function ServerRequest(opts1) {
    var err;
    this.opts = opts1 != null ? opts1 : {};
    ServerRequest.__super__.constructor.call(this, this.opts);
    err = "One of opts.api, opts.url, or opts.local_url must be set";
    this.__type = this._type || "GET";
    if (this._api) {
      CUI.util.assert(!this._url && !this._local_url, "new ServerRequest", err, {
        opts: this.opts
      });
      CUI.util.assert(this._api.startsWith("/"), "new ServerRequest", "opts.api needs to start with /", {
        opts: this.opts
      });
      this.__url = ez5.api.base(this.__server_url || "") + this._api;
      if (!this.opts.hasOwnProperty("withCredentials")) {
        this._withCredentials = true;
      }
    }
    if (this._url) {
      CUI.util.assert(!this._local_url, "new ServerRequest", err, {
        opts: this.opts
      });
      this.__url = this._url;
    }
    if (this._local_url) {
      this.__url = this._local_url;
    }
    if (this.__server_url && !this._local_url && this.__url.startsWith("/")) {
      this.__url = this.__server_url + this.__url;
    }
    this.__headers = CUI.util.copyObject(this._headers, true);
    this.__prepareRequest();
  }

  ServerRequest.prototype.readOpts = function() {
    var ref;
    ServerRequest.__super__.readOpts.call(this);
    if (this._remoteEasydb) {
      this.__server_url = this._remoteEasydb.getServerUrl();
      this.__server_token = this._remoteEasydb.getServerToken();
    } else {
      this.__server_url = window.easydb_server_url;
      this.__server_token = (ref = ez5.session) != null ? ref.token : void 0;
    }
    if (this.__server_url) {
      CUI.util.assert(this.__server_url.startsWith("http://") || this.__server_url.startsWith("https://"), "new ServerRequest", "server_url needs to start with http:// or https://");
    }
  };

  ServerRequest.prototype.initOpts = function() {
    ServerRequest.__super__.initOpts.call(this);
    return this.addOpts({
      success: {
        check: Function
      },
      error: {
        check: Function
      },
      cache: {
        deprecated: true,
        check: Boolean
      },
      handle_error: {
        check: Function
      },
      async: {
        deprecated: true,
        check: Boolean
      },
      api: {
        check: String
      },
      dataType: {
        check: String
      },
      json_data: {},
      body: {},
      headers: {
        "default": {},
        check: "PlainObject"
      },
      data: {},
      url: {
        check: String
      },
      local_url: {
        check: String
      },
      timeout: {
        check: function(v) {
          return v >= 0;
        }
      },
      type: {
        check: ["POST", "GET", "PUT", "DELETE", "HEAD"]
      },
      remoteEasydb: {
        check: function(v) {
          return v instanceof RemoteEasydb;
        }
      },
      add_token: {
        "default": true,
        check: Boolean
      },
      skip_connector: {
        check: Boolean
      },
      dump_only: {
        "default": false,
        check: Boolean
      },
      dump_only_promise_policy: {
        "default": "reject",
        check: ["reject", "resolve"]
      },
      withCredentials: {
        mandatory: true,
        "default": false,
        check: Boolean
      }
    });
  };

  ServerRequest.prototype.getServerUrl = function() {
    return this.__server_url;
  };

  ServerRequest.prototype.start = function() {
    var dfr, fn, i, k, len, promise, ref;
    dfr = new CUI.Deferred();
    if (this._success) {
      dfr.done((function(_this) {
        return function(data, status, statusText) {
          return _this._success(data, status, _this.__xhr.getXHR());
        };
      })(this));
    }
    if (this._error) {
      dfr.fail((function(_this) {
        return function(data, status, statusText) {
          return _this._error(_this.__xhr.getXHR(), statusText);
        };
      })(this));
    }
    if (this._dump_only) {
      console.debug("ServerRequest", this.req);
      console.debug(this.req.method, this.req.url);
      if (this.req.json_data) {
        console.debug(CUI.util.dump(this.req.json_data));
      }
      dfr[this._dump_only_promise_policy]();
      return dfr.promise();
    }
    this.__doRequest(dfr);
    promise = dfr.promise();
    ref = ["abort"];
    fn = (function(_this) {
      return function(k) {
        return promise[k] = function() {
          return _this.__xhr[k].apply(_this.__xhr, arguments);
        };
      };
    })(this);
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      fn(k);
    }
    return promise;
  };

  ServerRequest.prototype.handle202 = function(dfr, data) {
    var form_data, show_task_modal;
    form_data = {};
    show_task_modal = function(task_idx, tasks_dfr) {
      var btn, buttons, f, field, fields, fn, form, get_text, i, index, j, l, len, len1, len2, mod, opt, ref, ref1, ref2, set_buttons_state, task;
      if (tasks_dfr == null) {
        tasks_dfr = new CUI.Deferred();
      }
      if (!(task = data.tasks[task_idx])) {
        tasks_dfr.resolve();
        return;
      }
      dfr.notify("start", task_idx, data.tasks.length);
      fields = [];
      get_text = (function(_this) {
        return function(obj) {
          if (CUI.util.isPlainObject(obj)) {
            return $$(obj.code, obj.parameters);
          }
          return "" + obj;
        };
      })(this);
      if (task.form) {
        ref = task.form;
        for (i = 0, len = ref.length; i < len; i++) {
          f = ref[i];
          if (f.name) {
            form_data[f.name] = void 0;
          }
          field = {
            form: {
              label: get_text(f.label)
            }
          };
          switch (f.type) {
            case "options":
              field.undo_and_changed_support = false;
              field.type = CUI.Options;
              field.name = f.name;
              field.ui = "task.modal.field:" + f.name;
              field.radio = true;
              field.horizontal = f.horizontal;
              ref1 = f.options;
              for (index = j = 0, len1 = ref1.length; j < len1; index = ++j) {
                opt = ref1[index];
                if (opt.text) {
                  opt.text = get_text(opt.text);
                  opt.ui = "task.modal.field:" + f.name + ":" + index;
                }
              }
              field.options = f.options;
              break;
            default:
              CUI.util.assert(false, "ServerRequest.handle202", "Unknown field in task.form", {
                task: task
              });
          }
          fields.push(field);
        }
        form = new CUI.Form({
          onDataChanged: function() {
            return set_buttons_state();
          },
          "class": "server-request-handle-202-form",
          ui: "task.modal",
          data: form_data,
          fields: fields
        });
        form.start();
      } else {
        form = null;
      }
      buttons = [];
      if (task.buttons) {
        ref2 = task.buttons;
        fn = function(btn) {
          return buttons.push(new CUI.Button({
            text: get_text(btn.text),
            ui: "task.modal.button:" + (btn.name || index),
            onClick: function() {
              if (btn.name) {
                form_data[btn.name] = btn.value;
              }
              mod.destroy();
              dfr.notify("confirmed", task_idx, data.tasks.length);
              show_task_modal(task_idx + 1, tasks_dfr);
            }
          }));
        };
        for (index = l = 0, len2 = ref2.length; l < len2; index = ++l) {
          btn = ref2[index];
          if (btn.hidden) {
            CUI.util.assert(btn.name && btn.hasOwnProperty("value"), "ServerRequest.handle202", "btn.hidden needs button name and btn.value to be set.", {
              button: btn
            });
            form_data[btn.name] = btn.value;
            continue;
          }
          fn(btn);
        }
      } else {
        CUI.util.assert(false, "ServerRequest.handle202", "Task did not provide a button", {
          task: task
        });
      }
      set_buttons_state = function() {
        var df, form_ok, len3, len4, m, n, o, ref3;
        if (!form) {
          form_ok = true;
        } else {
          form_ok = true;
          ref3 = form.getDataFields();
          for (m = 0, len3 = ref3.length; m < len3; m++) {
            df = ref3[m];
            if (n = df.getName()) {
              if (CUI.util.isFalse(form_data[n])) {
                form_ok = false;
                break;
              }
            }
          }
        }
        for (o = 0, len4 = buttons.length; o < len4; o++) {
          btn = buttons[o];
          if (form_ok) {
            btn.enable();
          } else {
            btn.disable();
          }
        }
      };
      mod = new CUI.ConfirmationDialog({
        "class": "ez5-server-request-handle-202",
        title: get_text(task.title),
        cancel: true,
        onCancel: function() {
          tasks_dfr.reject(task_idx);
        },
        content: function() {
          var div202Content, div202Message;
          div202Content = CUI.dom.div("server-request-handle-202-content");
          div202Message = CUI.dom.div("server-202-message");
          CUI.dom.append(div202Message, new CUI.Label({
            markdown: true,
            multiline: true,
            text: get_text(task.message)
          }));
          CUI.dom.append(div202Content, div202Message);
          if (form) {
            CUI.dom.append(div202Content, form);
          }
          return div202Content;
        },
        buttons: buttons
      });
      set_buttons_state();
      mod.show();
      return tasks_dfr.promise();
    };
    return show_task_modal(0).done((function(_this) {
      return function() {
        var k, v;
        dfr.notify("done");
        CUI.util.assert(!CUI.util.isEmptyObject(form_data), "ServerRequest.handle202", "Server did not provide at least one \"name\" field or button.", {
          form_data: form_data
        });
        _this.req.url = _this.__url;
        _this.req.url_data = _this._data || {};
        for (k in form_data) {
          v = form_data[k];
          _this.req.url_data[k] = v;
        }
        return _this.__doRequest(dfr);
      };
    })(this)).fail(function(task_idx) {
      return dfr.reject("cancelled", task_idx, data.tasks.length);
    });
  };

  ServerRequest.prototype.handle502 = function(dfr) {
    if (!ServerRequest.bad_gateway_modal) {
      ServerRequest.bad_gateway_modal = new CUI.AlertProblem({
        choices: [],
        title: $$("server.error.bad_gateway.title"),
        text: $$("server.error.bad_gateway.text")
      });
      ServerRequest.bad_gateway_modal.open();
    }
    if (!this.__502_in_progress) {
      this.__502_in_progress = true;
      dfr.done((function(_this) {
        return function() {
          var ref;
          if ((ref = ServerRequest.bad_gateway_modal) != null) {
            ref.destroy();
          }
          delete ServerRequest.bad_gateway_modal;
          return delete _this.__502_in_progress;
        };
      })(this));
    }
    CUI.setTimeout((function(_this) {
      return function() {
        return _this.__doRequest(dfr);
      };
    })(this), 2500);
  };

  ServerRequest.__active = 0;

  ServerRequest.hasRequests = function() {
    return this.__active > 0;
  };

  ServerRequest.prototype.__doRequest = function(dfr) {
    var handleRefreshToken;
    handleRefreshToken = (function(_this) {
      return function() {
        _this.__server_token = ez5.session.token;
        if (ez5.version("6.1")) {
          _this.__headers["Authorization"] = "Bearer " + _this.__server_token;
        } else {
          _this.__headers["X-Easydb-Token"] = _this.__server_token;
        }
        return _this.__doRequest(dfr);
      };
    })(this);
    this.__xhr = new CUI.XHR(this.req);
    this.__xhr.start().done((function(_this) {
      return function(data, status, statusText) {
        if (status === 202) {
          _this.handle202(dfr, data);
          return;
        }
        return dfr.resolve(data, status, _this.__xhr.getXHR());
      };
    })(this)).fail((function(_this) {
      return function(data, status, statusText) {
        var error_args, ref;
        if (ez5.version("6") && window.easydb_refreshing_token && !((ref = _this.__xhr._json_data) != null ? ref.refresh_token : void 0)) {
          window.easydb_refreshing_token.done(function() {
            return handleRefreshToken();
          }).fail(function() {
            ez5.login.redirectToOAUTH2Login();
          });
          return;
        }
        if (ez5.version("6") && status === 401 && (data != null ? data.code : void 0) === "AuthSessRequired" && CUI.getSessionStorage("token")) {
          if (!window.easydb_refreshing_token) {
            window.easydb_refreshing_token = ez5.session.refresh().done(function() {
              handleRefreshToken();
            }).fail(function() {
              ez5.login.redirectToOAUTH2Login();
            }).always(function() {
              return window.easydb_refreshing_token = null;
            });
          }
          return;
        }
        error_args = [_this.__xhr.getXHR(), statusText];
        switch (typeof _this._handle_error === "function" ? _this._handle_error(_this.__xhr.getXHR()) : void 0) {
          case true:
            dfr.reject.apply(dfr, error_args);
            return;
        }
        if (status === 502) {
          _this.handle502(dfr);
          return;
        }
        if (!_this._error && statusText !== "abort") {
          return ez5.error_handler(_this.__xhr.getXHR(), _this).done(function() {
            return dfr.reject.apply(dfr, error_args);
          }).fail(function() {
            return _this.__doRequest(dfr);
          });
        } else {
          return dfr.reject.apply(dfr, error_args);
        }
      };
    })(this)).progress(function() {
      return dfr.notify.apply(dfr, arguments);
    });
    return this;
  };

  ServerRequest.prototype.__prepareRequest = function() {
    var ref;
    this.req = {
      method: this.__type,
      url: this.__url,
      url_data: this._data,
      body: this._body,
      timeout: this._timeout,
      json_data: this._json_data,
      json_pretty: true || ((ref = ez5.session) != null ? ref.isDebug() : void 0) ? "   " : void 0,
      responseType: this._dataType,
      headers: this.__headers,
      withCredentials: this._withCredentials
    };
    if (this._add_token && this.__server_token) {
      if (ez5.version("6.1")) {
        this.__headers["Authorization"] = "Bearer " + this.__server_token;
        return this.__headers["X-Fylr-Authorization"] = "Bearer " + this.__server_token;
      } else {
        return this.__headers["X-Easydb-Token"] = this.__server_token;
      }
    }
  };

  ServerRequest.prototype.getRequest = function() {
    return this.req;
  };

  return ServerRequest;

})(CUI.Element);

ez5.server = function(opts) {
  return (new ServerRequest(opts)).start();
};
// Generated by CoffeeScript 1.12.7
var ServerRequestApi,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

ServerRequestApi = (function(superClass) {
  extend(ServerRequestApi, superClass);

  function ServerRequestApi(opts1) {
    var api, defaults, fn, ref;
    this.opts = opts1 != null ? opts1 : {};
    ServerRequestApi.__super__.constructor.call(this, this.opts);
    ref = ServerRequestApi.apis;
    fn = (function(_this) {
      return function(api, defaults) {
        return _this[api] = function(opts) {
          if (opts == null) {
            opts = {};
          }
          CUI.util.mergeMap(opts, defaults);
          return _this.__call(api, opts);
        };
      };
    })(this);
    for (api in ref) {
      defaults = ref[api];
      fn(api, defaults);
    }
    return;
  }

  ServerRequestApi.prototype.base = function(server) {
    if (server) {
      return server + "/api/v1";
    }
    return window.easydb_base_prefix + "/api/v1";
  };

  ServerRequestApi.getXEasydbHeaders = function(xhr) {
    var x_easydb;
    if (ez5.version("6")) {
      return {
        fylrCacheId: xhr.getResponseHeader("X-Fylr-Cache-Id")
      };
    }
    x_easydb = {
      base: xhr.getResponseHeader("X-Easydb-Base-Schema-Version"),
      user: xhr.getResponseHeader("X-Easydb-User-Schema-Version"),
      solution: xhr.getResponseHeader("X-Easydb-Solution")
    };
    if (!x_easydb.base) {
      return;
    }
    return x_easydb;
  };

  ServerRequestApi.prototype.getFullBase = function() {
    if (window.easydb_server_url) {
      return this.base(window.easydb_server_url);
    }
    return this.base();
  };

  ServerRequestApi.prototype.__call = function(api, opts) {
    if (opts.api) {
      CUI.util.assert(opts.api.startsWith("/"), "ez5.api." + api, "opts.api needs to start with /", {
        opts: opts
      });
      opts.api = "/" + api + opts.api;
    } else {
      opts.api = "/" + api;
    }
    return (new ServerRequest(opts)).start().done((function(_this) {
      return function(_1, _2, xhr) {
        var x_easydb;
        x_easydb = ServerRequestApi.getXEasydbHeaders(xhr);
        if (x_easydb) {
          ez5.session.__x_easydb = x_easydb;
        }
      };
    })(this));
  };

  ServerRequestApi.prototype.search_no_limit = function(_req) {
    var data, debug, dfr, limit, load_next_chunk, offset, req, ret_promise;
    if (_req == null) {
      _req = {};
    }
    limit = _req.json_data.limit || 0;
    if ((_req.json_data.limit || 0) <= 1000) {
      return this.search(_req);
    }
    req = CUI.util.copyObject(_req, true);
    if (!req.data) {
      req.data = {};
    }
    if (!req.data.debug) {
      req.data.debug = "";
    }
    if (req.data.debug) {
      debug = req.data.debug + "--";
    } else {
      debug = "";
    }
    offset = req.json_data.offset || 0;
    data = null;
    req.json_data.limit = 1000;
    dfr = new CUI.Deferred();
    load_next_chunk = (function(_this) {
      return function() {
        var chunk_promise;
        req.json_data.offset = offset;
        req.data.debug = debug + (offset + "-" + limit);
        delete req.api;
        chunk_promise = _this.search(req).fail(dfr.reject).done(function(_data) {
          var i, len, obj, ref;
          if (data === null) {
            data = _data;
          } else {
            data.limit = _data.limit + data.limit;
            ref = _data.objects;
            for (i = 0, len = ref.length; i < len; i++) {
              obj = ref[i];
              data.objects.push(obj);
            }
          }
          if (_data.offset + 1000 < Math.min(_data.count, limit)) {
            offset = offset + 1000;
            return load_next_chunk();
          } else {
            return dfr.resolve(data);
          }
        });
        return ret_promise.abort = function() {
          return chunk_promise.abort();
        };
      };
    })(this);
    ret_promise = dfr.promise();
    load_next_chunk();
    return ret_promise;
  };

  ServerRequestApi.apis = {
    search: {
      type: "POST",
      data: {
        pretty: 0
      }
    },
    db: {
      type: "POST"
    },
    settings: {},
    publish: {
      type: "POST"
    },
    "export": {},
    schema: {},
    objects: {},
    objecttype: {},
    collection: {},
    config: {},
    suggest: {},
    eas: {},
    settings: {},
    system: {},
    tags: {},
    transitions: {},
    mask: {},
    l10n: {},
    plugin: {},
    db_info: {
      type: "POST"
    },
    session: {},
    event: {},
    right: {},
    message: {},
    xmlmapping: {},
    user: {},
    group: {},
    pool: {}
  };

  return ServerRequestApi;

})(CUI.Element);

ez5.api = new ServerRequestApi();
// Generated by CoffeeScript 1.12.7
var $$, $empty$, $span$, Localization,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

Localization = (function(superClass) {
  extend(Localization, superClass);

  function Localization() {
    return Localization.__super__.constructor.apply(this, arguments);
  }

  Localization.prototype.init = function() {
    this.__multiInputControl = new LanguageControl();
    this.__multiInputControlDetail = new LanguageControl();
    return this.__multiInputControlAdmin = new LanguageControlAdmin();
  };

  Localization.prototype.getPreferredDatabaseLanguage = function() {
    return ez5.session.getPref("database_languages")[0];
  };

  Localization.prototype.getLanguageControl = function() {
    return this.__multiInputControl;
  };

  Localization.prototype.getLanguageControlDetail = function() {
    return this.__multiInputControlDetail;
  };

  Localization.prototype.getLanguageControlAdmin = function() {
    return this.__multiInputControlAdmin;
  };

  Localization.prototype.getFirstStandardText = function(standard) {
    var ref;
    return (ref = standard["1"] || standard["2"] || standard["3"]) != null ? ref.text : void 0;
  };

  Localization.prototype.getDatabaseLanguages = function() {
    return ez5.session.getPref("database_languages");
  };

  Localization.prototype.getSearchLanguages = function() {
    return ez5.session.getPref("search_languages");
  };

  Localization.prototype.getBestFrontendValue = function(data, html, html_only) {
    if (html == null) {
      html = false;
    }
    if (html_only == null) {
      html_only = false;
    }
    return this.__getBestValue(data, html, html_only, true);
  };

  Localization.prototype.getBestDatabaseValue = function(data, html, html_only) {
    if (html == null) {
      html = false;
    }
    if (html_only == null) {
      html_only = false;
    }
    return this.__getBestValue(data, html, html_only, false);
  };

  Localization.sid_match = new RegExp("(^|>)#[1-9][0-9]*($|<)");

  Localization.prototype.__getBestValue = function(data, html, html_only, frontend) {
    var i, j, k, lang, len, len1, sid_v, try_languages, v;
    if (!data) {
      return;
    }
    try_languages = [];
    if (frontend) {
      try_languages.push(this.getLanguage());
      try_languages.push.apply(try_languages, ez5.session.getConfigFrontendLanguages());
    } else {
      try_languages.push.apply(try_languages, ez5.session.getPref("database_languages"));
      try_languages.push.apply(try_languages, ez5.session.getConfigDatabaseLanguages());
    }
    if (html) {
      for (i = 0, len = try_languages.length; i < len; i++) {
        lang = try_languages[i];
        v = data[lang + ":highlight"];
        if (CUI.util.isEmpty(v)) {
          continue;
        }
        if (Localization.sid_match.exec(v)) {
          continue;
        }
        return v;
      }
    }
    if (!html_only) {
      for (j = 0, len1 = try_languages.length; j < len1; j++) {
        lang = try_languages[j];
        v = data[lang];
        if (CUI.util.isEmpty(v)) {
          continue;
        }
        if (Localization.sid_match.exec(v)) {
          continue;
        }
        if (html) {
          return CUI.util.toHtml(v);
        } else {
          return v;
        }
      }
    }
    sid_v = void 0;
    if (html) {
      for (k in data) {
        v = data[k];
        if (k === "_comment") {
          continue;
        }
        if (CUI.util.isEmpty(v)) {
          continue;
        }
        if (Localization.sid_match.exec(v)) {
          sid_v = v;
          continue;
        }
        if (k.match(/:highlight$/)) {
          return v;
        }
      }
      if (html_only) {
        return sid_v;
      }
    }
    for (k in data) {
      v = data[k];
      if (k === "_comment") {
        continue;
      }
      if (CUI.util.isEmpty(v)) {
        continue;
      }
      if (Localization.sid_match.exec(v)) {
        sid_v = v;
        continue;
      }
      if (html) {
        return CUI.util.toHtml(v);
      } else {
        return v;
      }
    }
    if (sid_v !== void 0) {
      if (html) {
        return CUI.util.toHtml(sid_v);
      } else {
        return sid_v;
      }
    }
  };

  Localization.prototype.setLanguage = function(culture) {
    var ref;
    CUI.util.assert((culture != null ? culture.length : void 0) === 5, "Localization.setLanguage", "Culture needs to be set");
    if (culture === this.culture) {
      return CUI.resolvedPromise();
    }
    this.culture = culture;
    CUI.DateTime.setLocale(this.culture);
    document.documentElement.setAttribute("lang", this.culture.split('-')[0]);
    return CUI.when(this.load_keys(), null, (ref = ez5.pluginManager) != null ? ref.loadKeys() : void 0);
  };

  Localization.prototype.getLanguage = function() {
    return this.culture;
  };

  Localization.prototype.str_span = function(key, attrs, culture) {
    var span;
    span = CUI.dom.span("loca-key loca-key-" + key.replace(/[\.]/g, "-"));
    span.textContent = this.str(key, attrs, culture);
    return span;
  };

  Localization.prototype.str_default = function(key, _default, attrs, culture) {
    if (_default == null) {
      _default = null;
    }
    return this.str(key, attrs, culture, _default);
  };

  Localization.prototype.html = function(key, attrs, culture, _default) {
    var html;
    if (culture == null) {
      culture = this.culture;
    }
    if (_default == null) {
      _default = void 0;
    }
    return html = this.str(key, attrs, culture, _default, true);
  };

  Localization.prototype.str = function(key, attrs, culture, _default, as_html) {
    var _str, matches, r, s, str;
    if (culture == null) {
      culture = this.culture;
    }
    if (CUI.util.isUndef(key)) {
      return "";
    }
    str = this.get_key(key, culture);
    if (str === "-") {
      return "";
    }
    if (CUI.util.isEmpty(str)) {
      if (_default !== void 0) {
        if (_default === null) {
          return null;
        }
        str = _default;
      } else {
        str = culture + ":" + key;
      }
      if (as_html) {
        return CUI.util.toHtml(str);
      } else {
        return str;
      }
    }
    if (as_html) {
      str = CUI.util.toHtml(str);
    }
    if (str.indexOf("$(") > -1) {
      r = /\$\((.*?)\)/g;
      s = "" + str;
      while (matches = r.exec(str)) {
        _str = this.get_key(matches[1], culture);
        if (CUI.util.isEmpty(_str)) {
          _str = culture + ":" + matches[1];
        }
        s = s.split(matches[0]).join(_str);
      }
      str = s;
    }
    if (attrs) {
      return this.replAttr(str, attrs);
    } else {
      if (ez5.session.getPref("debug_locakeys")) {
        return key;
      }
      return str;
    }
  };

  Localization.replRegex = /%(?:([1-9][0-9]*)(i)|\(([^]+?)\)([a-zA-Z]))/g;

  Localization.prototype.replAttr = function(s, attrs, level) {
    var _key, append, getFormattedValue, getValue, key, matches, modifier, parts, prepend, repl, value, values;
    if (level == null) {
      level = 0;
    }
    while (matches = Localization.replRegex.exec(s)) {
      prepend = null;
      append = null;
      if (matches[1]) {
        key = parseInt(matches[1]) - 1;
        modifier = matches[2];
      } else {
        _key = matches[3];
        modifier = matches[4];
        if (_key.indexOf("|") === -1) {
          key = _key;
        } else {
          parts = _key.split("|");
          switch (parts.length) {
            case 3:
              prepend = parts[0];
              key = parts[1];
              append = parts[2];
              break;
            case 2:
              if (attrs[parts[0]]) {
                prepend = "";
                key = parts[0];
                append = parts[1];
              } else if (attrs[parts[1]]) {
                prepend = parts[0];
                key = parts[1];
                append = "";
              } else {
                key = _key;
              }
              break;
            default:
              key = _key;
          }
        }
      }
      getValue = (function(_this) {
        return function(attrs, key) {
          return eval("attrs." + key);
        };
      })(this);
      if ((typeof key.indexOf === "function" ? key.indexOf(".") : void 0) > -1) {
        repl = getValue(attrs, key);
      } else {
        repl = attrs[key];
      }
      if (CUI.util.isNull(repl)) {
        repl = "(attrs." + (matches[1] || matches[2]) + " missing)";
      } else {
        getFormattedValue = (function(_this) {
          return function(value) {
            var column, formattedValue, table, unknownModifierText;
            formattedValue = (function() {
              var ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8;
              switch (modifier) {
                case "c":
                  ref = value.split("."), table = ref[0], column = ref[1];
                  return ((ref1 = ez5.schema.CURRENT._table_by_name) != null ? (ref2 = ref1[table]) != null ? (ref3 = ref2._column_by_name[column]) != null ? ref3._name_localized : void 0 : void 0 : void 0) || value;
                case "t":
                  return ((ref4 = ez5.schema.CURRENT._table_by_name) != null ? (ref5 = ref4[value]) != null ? ref5._name_localized : void 0 : void 0) || value;
                case "i":
                case "s":
                  return value;
                case "D":
                  return ez5.format_date(value);
                case "d":
                  return ez5.format_date_and_time(value);
                case "p":
                  return ((ref6 = ez5.pools.findPoolById(value)) != null ? ref6.getDisplayText() : void 0) || value;
                case "g":
                  return ((ref7 = ez5.groupManager.getGroupById(value)) != null ? ref7.getDisplayText() : void 0) || value;
                case "m":
                  return ((ref8 = ez5.mask.CURRENT._mask_by_id[value]) != null ? ref8._name_localized : void 0) || value;
                case "r":
                  key = "server.right." + value;
                  if (this.has(key)) {
                    return $$(key);
                  } else {
                    return value;
                  }
                  break;
                case "o":
                  return "#" + value;
                default:
                  modifier = matches[3];
                  key = matches[2];
                  unknownModifierText = "('" + key + "': UNKNOWN MODIFIER '" + modifier + "')";
                  return unknownModifierText;
              }
            }).call(_this);
            if (prepend || append) {
              return prepend + formattedValue + append;
            } else {
              return formattedValue;
            }
          };
        })(this);
        if (CUI.util.isArray(repl)) {
          values = (function() {
            var i, len, results;
            results = [];
            for (i = 0, len = repl.length; i < len; i++) {
              value = repl[i];
              results.push(getFormattedValue(value));
            }
            return results;
          })();
          if (prepend === null && append === null) {
            repl = values.join(", ");
          } else {
            repl = values.join("");
          }
        } else {
          repl = getFormattedValue(repl);
        }
      }
      s = s.split(matches[0]).join(repl);
    }
    if (level < 2) {
      return this.replAttr(s, attrs, level + 1);
    } else {
      return s;
    }
  };

  Localization.prototype.get_complete_key = function(key, culture) {
    var _key;
    if (culture == null) {
      culture = this.culture;
    }
    _key = {};
    _key[this.culture] = this.get_key(key, culture);
    return _key;
  };

  Localization.prototype.get_key = function(key, culture) {
    var ref, v;
    if (culture == null) {
      culture = this.culture;
    }
    if (!this.strings) {
      return void 0;
    }
    if (!this.strings[culture]) {
      return void 0;
    }
    v = this.strings[culture][key + "[" + ((ref = ez5.cssLoader.getActiveCSS()) != null ? ref.theme : void 0) + "]"];
    if (!CUI.util.isUndef(v)) {
      return v;
    }
    return this.strings[culture][key];
  };

  Localization.prototype.has = function(key) {
    return !CUI.util.isUndef(this.get_key(key));
  };

  Localization.prototype.clean_keys = function(map) {
    var _map, culture, found, k, v, value;
    for (k in map) {
      v = map[k];
      _map = {};
      found = false;
      for (culture in v) {
        value = v[culture];
        if (!CUI.util.isEmpty(value)) {
          _map[culture] = value;
          found = true;
        }
      }
      if (found) {
        map[k] = _map;
      } else {
        delete map[k];
      }
    }
    return map;
  };

  Localization.prototype.get_valid_user_key_prefixes = function(version) {
    var i, j, len, len1, mask, prefixes, ref, ref1, table;
    prefixes = [];
    ref = ez5.schema[version].tables;
    for (i = 0, len = ref.length; i < len; i++) {
      table = ref[i];
      prefixes.push("schema." + table.name + ".");
    }
    ref1 = ez5.mask[version].masks;
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      mask = ref1[j];
      if (mask.name) {
        prefixes.push("mask." + mask.table_id + "." + mask.name + ".");
      } else {
        prefixes.push("mask." + mask.table_id + "._new_.");
      }
    }
    return prefixes;
  };

  Localization.prototype.update = function(opts) {
    var delete_prefix, delete_prefixes, i, idx, key, len, ref, ref1, ref2, ref3, value;
    CUI.util.assert((ref = opts.realm) === "HEAD" || ref === "CURRENT", "Localization.update", "opts.realm needs to be \"HEAD\" or \"CURRENT\" but is \"" + opts.realm + "\".", {
      opts: opts
    });
    if (!this.user_keys || !this.user_keys[opts.realm]) {
      console.debug("ez5.loca.update: user_keys for realm '" + opts.realm + "' not loaded, cannot update.");
      return;
    }
    if (CUI.util.isArray(opts.delete_prefixes)) {
      delete_prefixes = opts.delete_prefixes.slice(0);
    } else {
      delete_prefixes = [];
    }
    if (CUI.util.isString(opts.delete_prefix)) {
      delete_prefixes.push(opts.delete_prefix);
    }
    for (i = 0, len = delete_prefixes.length; i < len; i++) {
      delete_prefix = delete_prefixes[i];
      ref1 = this.user_keys[opts.realm];
      for (key in ref1) {
        value = ref1[key];
        if (delete_prefix === key.substr(0, delete_prefix.length)) {
          delete this.user_keys[opts.realm][key];
        }
      }
    }
    if (CUI.util.isArray(opts.valid_prefixes)) {
      ref2 = this.user_keys[opts.realm];
      for (key in ref2) {
        value = ref2[key];
        if (!this.user_keys[opts.realm].hasOwnProperty(key)) {
          continue;
        }
        idx = CUI.util.idxInArray(key, opts.valid_prefixes, function(prefix) {
          return prefix === key.substr(0, prefix.length);
        });
        if (idx === -1) {
          console.warn("Localization.update: Removing not protected invalid key:", key);
          delete this.user_keys[opts.realm][key];
        }
      }
    }
    ref3 = opts.keys;
    for (key in ref3) {
      value = ref3[key];
      if (!CUI.util.isNull(value)) {
        this.user_keys[opts.realm][key] = value;
      }
    }
    return ez5.api.l10n({
      type: "POST",
      api: "/user/" + opts.realm,
      withCredentials: true,
      json_data: this.user_keys[opts.realm]
    });
  };

  Localization.prototype.load_keys = function(language) {
    var frontendLocaKeysData, serverLocaKeysData;
    if (language == null) {
      language = this.culture;
    }
    CUI.util.assert(language, "Localization.load_keys", "language is not set");
    this.strings = {};
    this.strings[language] = {};
    serverLocaKeysData = null;
    frontendLocaKeysData = null;
    return CUI.when(ez5.server({
      local_url: window.easydb_base_prefix + "/web/l10n/" + language + ".json",
      data: ez5.session.fylrCacheParams(),
      add_token: false
    }).done((function(_this) {
      return function(data) {
        frontendLocaKeysData = data;
      };
    })(this)), ez5.api.l10n({
      api: "/static/" + language + ".json",
      add_token: false,
      withCredentials: ez5.version("6"),
      data: ez5.session.fylrCacheParams()
    }).done((function(_this) {
      return function(data) {
        if (!CUI.util.isPlainObject(data)) {
          console.warn("Localization: load_keys", language, "no data returned.");
          return;
        }
        serverLocaKeysData = data;
      };
    })(this))).fail(function(xhr) {
      return console.error("error retrieving language", language, xhr);
    }).done((function(_this) {
      return function() {
        var iconColors, icons, k, key;
        _this.__addKeys(frontendLocaKeysData, language);
        if (serverLocaKeysData) {
          _this.__addKeys(serverLocaKeysData, language);
        }
        CUI.defaults["class"].Select.defaults.not_found = $$("cui.select.not_found");
        CUI.defaults["class"].Button.defaults.confirm_ok = $$("base.ok");
        CUI.defaults["class"].Button.defaults.confirm_cancel = $$("base.cancel");
        CUI.defaults["class"].Button.defaults.confirm_title = $$("base.confirm");
        CUI.defaults["class"].Label.defaults.manage_overflow.text_inactive = ez5.loca.text("label.manage_overflow|text_inactive");
        CUI.defaults["class"].Label.defaults.manage_overflow.text_active = ez5.loca.text("label.manage_overflow|text_active");
        CUI.defaults["class"].Label.defaults.manage_overflow.icon_inactive = "fa-plus-square-o";
        CUI.defaults["class"].Label.defaults.manage_overflow.icon_active = "fa-minus-square-o";
        CUI.Modal.defaults.cancel_tooltip = {
          text: $$("base.cancel.tooltip")
        };
        CUI.Pane.defaults.button_tooltip = {
          text: $$("base.pane.tooltip")
        };
        CUI.DateTime.defaults.button_tooltip = ez5.loca.text("cui.date.time.button_tooltip");
        CUI.DateTime.defaults.bc_appendix = ez5.loca.text("cui.date.time.bc_appendix").trim().split(";");
        CUI.DataTable.defaults.plus_button_tooltip = ez5.loca.text("cui.data.table.plus_button_tooltip");
        CUI.DataTable.defaults.minus_button_tooltip = ez5.loca.text("cui.data.table.minus_button_tooltip");
        CUI.ListView.defaults.row_move_handle_tooltip = ez5.loca.text("cui.list.view.row_move_handle_tooltip");
        CUI.Tabs.defaults.overflow_button_tooltip = ez5.loca.text("cui.tabs.overflow_button_tooltip");
        CUI.MapInput.defaults.labels.placeholder = ez5.loca.text("cui.map.input.placeholder");
        CUI.MapInput.defaults.labels.iconButtonTooltip = ez5.loca.text("cui.map.input.icon.button.tooltip");
        CUI.MapInput.defaults.labels.mapButtonTooltip = ez5.loca.text("cui.map.input.map.button.tooltip");
        CUI.MapInput.defaults.labels.iconLabel = ez5.loca.text("cui.map.input.map.popover.icon.label");
        CUI.MapInput.defaults.labels.colorLabel = ez5.loca.text("cui.map.input.map.popover.color.label");
        icons = ez5.loca.text("cui.map.input.map.popover.icons");
        iconColors = ez5.loca.text("cui.map.input.map.popover.icons-colors");
        if (icons) {
          CUI.MapInput.defaults.icons = icons.split(",");
        }
        if (iconColors) {
          CUI.MapInput.defaults.iconColors = iconColors.split(",");
        }
        CUI.Map.defaults.buttons.zoom.plus.icon = ez5.loca.text("cui.map.buttons.zoom.plus.icon");
        CUI.Map.defaults.buttons.zoom.plus.tooltip = ez5.loca.text("cui.map.buttons.zoom.plus.tooltip");
        CUI.Map.defaults.buttons.zoom.reset.icon = ez5.loca.text("cui.map.buttons.zoom.reset.icon");
        CUI.Map.defaults.buttons.zoom.reset.tooltip = ez5.loca.text("cui.map.buttons.zoom.reset.tooltip");
        CUI.Map.defaults.buttons.zoom.minus.icon = ez5.loca.text("cui.map.buttons.zoom.minus.icon");
        CUI.Map.defaults.buttons.zoom.minus.tooltip = ez5.loca.text("cui.map.buttons.zoom.minus.tooltip");
        CUI.Map.defaults.buttons.fullscreen.open.icon = ez5.loca.text("cui.map.buttons.fullscreen.open.icon");
        CUI.Map.defaults.buttons.fullscreen.close.icon = ez5.loca.text("cui.map.buttons.fullscreen.close.icon");
        CUI.Map.defaults.buttons.fullscreen.tooltip = ez5.loca.text("cui.map.buttons.fullscreen.tooltip");
        for (k in CUI.ConfirmationChoice.defaults) {
          key = "cui.confirmation.choice." + k;
          if (_this.has(key)) {
            CUI.ConfirmationChoice.defaults[k] = _this.get_key(key);
          }
        }
      };
    })(this));
  };

  Localization.prototype.__replaceValue = function(v) {
    return v.replace(/\\n/g, "\n").replace(/~/g, '\u00AD');
  };

  Localization.prototype.__addKeys = function(data, language) {
    var k, ref, v;
    if (!(data != null ? data[language] : void 0)) {
      return;
    }
    ref = data[language];
    for (k in ref) {
      v = ref[k];
      this.strings[language][k] = this.__replaceValue(v);
    }
  };

  Localization.prototype.load_more_keys = function(url) {
    var dfr;
    dfr = new CUI.Deferred();
    ez5.server({
      local_url: url,
      add_token: false,
      withCredentials: ez5.version("6"),
      handle_error: (function(_this) {
        return function(xhr) {
          return true;
        };
      })(this)
    }).done((function(_this) {
      return function(data) {
        var _data, i, len;
        if (CUI.util.isArray(data)) {
          for (i = 0, len = data.length; i < len; i++) {
            _data = data[i];
            if (_data._error) {
              console.error(_data._error);
              continue;
            }
            _this.__addKeys(_data, _this.getLanguage());
          }
        } else {
          _this.__addKeys(data, _this.getLanguage());
        }
        dfr.resolve(data);
      };
    })(this)).fail(dfr.reject);
    return dfr.promise();
  };

  Localization.prototype.set_user_keys = function(version, data) {
    var info, key, lang, value;
    this.user_keys[version] = {};
    for (key in data) {
      info = data[key];
      this.user_keys[version][key] = {};
      for (lang in info) {
        value = info[lang];
        if (lang === '_comment') {
          this.user_keys[version][key][lang] = value;
        } else {
          this.user_keys[version][key][lang] = Localization.prototype.__replaceValue.call(this, value);
        }
      }
    }
  };

  Localization.prototype.load_user_keys = function(x_easydb) {
    var cdata, loads;
    this.user_keys = {};
    if (x_easydb) {
      if (ez5.version("6")) {
        cdata = ez5.session.fylrCacheParams();
      } else {
        cdata = {
          cache_version: x_easydb.base + "-" + x_easydb.user,
          cache_seconds: 3600 * 24 * 100
        };
      }
    }
    loads = [
      ez5.api.l10n({
        api: "/user/CURRENT",
        withCredentials: true,
        data: cdata
      }).done((function(_this) {
        return function(data) {
          return _this.set_user_keys('CURRENT', data);
        };
      })(this))
    ];
    if (Datamodel.getLevel()) {
      loads.push(ez5.api.l10n({
        api: "/user/HEAD",
        withCredentials: true,
        data: ez5.session.fylrCacheParams()
      }).done((function(_this) {
        return function(data) {
          return _this.set_user_keys('HEAD', data);
        };
      })(this)));
    }
    return CUI.when(loads).fail(function(xhr) {
      return console.error("error loading user keys", this.culture, xhr);
    }).done(function() {});
  };

  Localization.prototype.has_user_key = function(realm, key) {
    var ref, ref1;
    return !CUI.util.isEmpty((ref = this.user_keys) != null ? (ref1 = ref[realm]) != null ? ref1[key] : void 0 : void 0);
  };

  Localization.prototype.get_user_key = function(realm, key) {
    if (key.indexOf('@') > -1) {
      return ez5.connector.get_user_key(realm, key);
    }
    if (!this.has_user_key(realm, key)) {
      return {};
    }
    return this.user_keys[realm][key];
  };

  Localization.prototype.has_user_key_localized = function(realm, key) {
    var keys;
    keys = this.get_user_key(realm, key);
    return !CUI.util.isEmpty(this.get_user_key_localized(realm, key));
  };

  Localization.prototype.get_user_key_localized = function(realm, key, _default) {
    var v;
    if (key.indexOf('@') > -1) {
      return ez5.connector.get_user_key_localized(realm, key, _default);
    }
    v = this.getBestFrontendValue(this.get_user_key(realm, key));
    if (CUI.util.isEmpty(v)) {
      return _default;
    } else {
      return v;
    }
  };

  Localization.prototype.text = function(key, attrs) {
    if (this.has(key + "|text")) {
      return this.str(key + "|text", attrs);
    } else if (this.has(key)) {
      return this.str(key, attrs);
    } else {
      return void 0;
    }
  };

  Localization.prototype.tooltip = function(key, attrs) {
    if (this.has(key + "|tooltip")) {
      return this.str(key + "|tooltip", attrs);
    } else {
      return null;
    }
  };

  Localization.prototype.formatNumber = function(int, fixed) {
    if (fixed == null) {
      fixed = 2;
    }
    return (int / Math.pow(10, fixed)).toFixed(fixed).replace("\.", ez5.session.frontend_locale.numbers.decimal);
  };

  Localization.prototype.setLocaKeys = function(div) {
    var el, i, len, loca_key, prefix, prefix_el, ref;
    ref = CUI.dom.matchSelector(div, "[data-loca-key]");
    for (i = 0, len = ref.length; i < len; i++) {
      el = ref[i];
      loca_key = el.getAttribute("data-loca-key");
      prefix_el = CUI.dom.closest(el, "[data-loca-key-prefix]");
      if (prefix_el) {
        prefix = prefix_el.getAttribute("data-loca-key-prefix");
      } else {
        prefix = "";
      }
      el.textContent = $$(prefix + loca_key);
    }
  };

  return Localization;

})(CUI.Element);

ez5.loca = new Localization();

$$ = function() {
  return ez5.loca.str.apply(ez5.loca, arguments);
};

$span$ = function() {
  return ez5.loca.str_span.apply(ez5.loca, arguments);
};

$empty$ = function() {
  return CUI.dom.addClass(ez5.loca.str_span.apply(ez5.loca, arguments), "italic");
};

ez5.session_ready((function(_this) {
  return function() {
    return ez5.loca.init();
  };
})(this));
