// Generated by CoffeeScript 1.12.7
var Start,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

console.time("Start");

Start = (function(superClass) {
  extend(Start, superClass);

  function Start() {
    Start.__super__.constructor.call(this);
    ez5.login = new Login();
    ez5.setDefaults();
    ez5.load_defaults((function(_this) {
      return function() {
        return _this.loadDefaults();
      };
    })(this));
  }

  Start.prototype.readOpts = function() {
    var server, serverUrl, url_parms;
    ez5.session = new Session();
    url_parms = CUI.decodeUrlData(document.location.search.substring(1));
    server = CUI.getSessionStorage("server");
    if (url_parms.server) {
      if (url_parms.server === "localhost") {
        server = "localhost";
      } else {
        server = Session.cleanServerUrl(url_parms.server);
      }
      this.removeFromUrl("server");
    } else if (!server) {
      server = ez5.session.getPref("easydb_server_url");
      if (!server) {
        server = "localhost";
      }
    }
    if (server === "localhost" && window.fylr_server) {
      server = window.fylr_server;
    }
    if (server !== "localhost") {
      serverUrl = new URL(server);
      CUI.setSessionStorage("server", serverUrl != null ? serverUrl.origin : void 0);
      window.easydb_server_url = CUI.getSessionStorage("server");
    } else {
      CUI.setSessionStorage("server", "localhost");
      window.easydb_server_url = "";
    }
    return console.info("Server set to:", window.easydb_server_url);
  };

  Start.prototype.removeFromUrl = function(key) {
    var new_search, parms, search;
    if (CUI.util.isEmpty(key)) {
      return;
    }
    search = document.location.search.substring(1);
    if (search.length === 0) {
      return;
    }
    parms = CUI.decodeUrlData(search);
    delete parms[key];
    new_search = CUI.encodeUrlData(parms);
    if (new_search.length > 0) {
      new_search = "?" + new_search;
    }
    return window.history.replaceState(null, null, document.location.origin + document.location.pathname + new_search + document.location.hash);
  };

  Start.prototype.displayError = function() {
    var btn, err, error;
    this.showSplash();
    console.warn("displaying generic error");
    error = "start.error.generic";
    if (!ez5.loca.has(error)) {
      err = "Fehler beim Laden / Error loading";
      btn = "Neu Laden / Try again";
    } else {
      err = $$(error);
      btn = $$("start.error.reload_button");
    }
    CUI.setSessionStorage("token", void 0);
    return CUI.problem({
      text: err,
      button_text_ok: btn,
      markdown: true
    }).done((function(_this) {
      return function() {
        return document.location.assign(window.easydb_base_prefix + "/");
      };
    })(this));
  };

  Start.prototype.showSplash = function() {
    this.__splash = new SplashLayer();
    return this.__splash.show();
  };

  Start.prototype.updateSplash = function() {
    var ref;
    return (ref = this.__splash) != null ? ref.update() : void 0;
  };

  Start.prototype.hideSplash = function() {
    var ref;
    if ((ref = this.__splash) != null) {
      ref.disappear();
    }
    return delete this.__splash;
  };

  Start.prototype.main = function() {
    ez5.pluginManager = new PluginManager({
      load_from_remote: ez5.session.getPref("plugins_load_from_remote"),
      remote_url: ez5.session.getPref("plugins_remote_url")
    });
    this.setVersion().done((function(_this) {
      return function() {
        _this.drawRootLayout();
        return ez5.pluginManager.loadPluginInfo(15000).fail(function() {
          return _this.tellProblem();
        }).done(function() {
          return _this.getSession().done(function() {
            _this.rootLayoutNorth.append(_this.getLogo(), "right");
            return ez5.pluginManager.loadPlugins().always(function() {
              _this.loadSession();
            }).fail(function() {
              CUI.problem({
                text: $$("start.error.plugins")
              });
            });
          });
        });
      };
    })(this));
  };

  Start.prototype.drawRootLayout = function() {
    var wb;
    this.rootLayoutNorth = new CUI.PaneHeader();
    this.rootLayoutSouth = new CUI.PaneFooter();
    ez5.rootLayout = new CUI.VerticalLayout({
      "class": "cui-root-layout",
      absolute: true,
      center: {
        "class": "ez5-root-layout-center"
      },
      top: {
        "class": "ez5-root-layout-top",
        content: this.rootLayoutNorth
      },
      bottom: {
        "class": "ez5-root-layout-bottom",
        content: this.rootLayoutSouth
      }
    });
    ez5.rootMenu = new RootMenu();
    this.rootLayoutNorth.replace(ez5.rootMenu.getDisplay(), "left");
    wb = new CUI.WaitBlock({
      element: ez5.rootLayout.center()
    });
    wb.show();
    this.__checkKnownServer();
    ez5.tray = new Tray();
    ez5.session.loadTheme().always((function(_this) {
      return function() {
        return CUI.dom.prepend(document.body, ez5.rootLayout.DOM);
      };
    })(this));
  };

  Start.prototype.getSession = function() {
    var token;
    console.timeLog("Start", "getting session");
    token = CUI.getSessionStorage("token");
    console.debug("token", token);
    return ez5.session.get(token).fail((function(_this) {
      return function(xhr) {
        var ref, ref1;
        if ((ref = (ref1 = xhr.responseJSON) != null ? ref1.code : void 0) === 'error.user.session_not_found' || ref === 'error.api.cookie_check_failed') {
          CUI.setSessionStorage("token", void 0);
          return _this.getSession();
        } else {
          return ez5.error_handler(xhr).done(function() {
            return _this.displayError();
          });
        }
      };
    })(this)).done((function(_this) {
      return function() {
        return console.timeLog("Start", "got session");
      };
    })(this));
  };

  Start.prototype.setVersion = function() {
    var dfr, version;
    dfr = new CUI.Deferred();
    dfr.done((function(_this) {
      return function() {
        var auth, token;
        console.debug(window.easydb_server_url, window.fylr_server);
        ez5.settings = {
          version: version
        };
        ez5.tokenParam = ez5.version("6.1") ? "access_token" : "token";
        console.debug("Setting version to", ez5.settings.version);
        token = CUI.getSessionStorage("token");
        if (!token && ez5.version("6")) {
          auth = ez5.session.getAuthMethodFromURL();
          return ez5.login.redirectToOAUTH2Login();
        }
      };
    })(this));
    if (window.easydb_server_url === window.fylr_server) {
      version = window.version;
      dfr.resolve();
    } else if (!window.easydb_server_url) {
      version = "v" + ez5.FRONTEND_VERSION;
      dfr.resolve();
    } else {
      ez5.api.settings({
        timeout: 15000,
        handle_error: (function(_this) {
          return function(xhr) {
            return true;
          };
        })(this)
      }).fail((function(_this) {
        return function(xhr, status) {
          console.debug("this", _this);
          return _this.tellProblem(status);
        };
      })(this)).done((function(_this) {
        return function(settings) {
          console.timeLog("Start", "settings loaded");
          version = settings.version;
          return dfr.resolve();
        };
      })(this));
    }
    return dfr.promise();
  };

  Start.prototype.loadSession = function() {
    return ez5.session.getReady().done((function(_this) {
      return function() {
        return ez5.session.loadTheme().always(function() {
          console.timeLog("Start", "theme 2");
          return _this.sessionReady();
        });
      };
    })(this)).fail((function(_this) {
      return function(reason) {
        if (reason === "goto_login") {
          if (ez5.version("6")) {
            ez5.login.redirectToOAUTH2Login();
            return;
          }
          ez5.login.showLogin().done(function() {
            return _this.loadSession();
          });
          return;
        }
        console.error("Start: Session.getReady failed:", reason);
        return CUI.problem({
          text: $$(reason.error)
        }).done(function() {
          CUI.setSessionStorage("token", void 0);
          return ez5.login.showLogin().done(function() {
            return _this.loadSession();
          });
        });
      };
    })(this));
  };

  Start.prototype.sessionReady = function() {
    return CUI.when(ez5.load_defaults(), ez5.session_ready()).done((function(_this) {
      return function() {
        return _this.loadApps().always(function() {
          return console.timeEnd("Start");
        });
      };
    })(this)).fail((function(_this) {
      return function() {
        return _this.displayError();
      };
    })(this));
  };

  Start.prototype.loadApps = function() {
    console.timeLog("Start", "loading tray apps");
    console.timeLog("Start", "loading apps");
    return CUI.when(ez5.tray.loadApps().always((function(_this) {
      return function() {
        return console.timeLog("Start", "tray apps loaded");
      };
    })(this)).done((function(_this) {
      return function() {
        _this.rootLayoutNorth.replace(ez5.tray.getDisplay(), "right");
        return _this.rootLayoutNorth.append(_this.getLogo(), "right");
      };
    })(this)), ez5.rootMenu.loadApps().always((function(_this) {
      return function() {
        return console.timeLog("Start", "apps loaded");
      };
    })(this))).fail((function(_this) {
      return function() {
        if (ez5.session.getAuthMethod() === "anonymous") {
          console.timeEnd("Start");
          return ez5.session.loginAgain(true, true);
        }
      };
    })(this));
  };

  Start.prototype.tellProblem = function(status) {
    var buttonTextOk, language, ref, server, text;
    server = CUI.parseLocation(window.easydb_server_url || document.location.href);
    language = ((ref = navigator.languages) != null ? ref[0] : void 0) || navigator.language || "de";
    language = language.split("-")[0];
    if (status === "timeout") {
      if (language === "de") {
        text = "Die easydb [**" + server.hostname + "**](" + server.origin + ") ist aktuell beschäftigt. Bitte versuchen Sie es in ein paar Minuten nochmal oder wenden Sie sich an den Support, sollte das Problem weiterhin bestehen.";
      } else {
        text = "The server [**" + server.hostname + "**](" + server.origin + ") is currently busy. Please try again in a few minutes, or contact support if this problem persists.";
      }
    } else {
      if (language === "de") {
        text = "Die easydb [**" + server.hostname + "**](" + server.origin + ") ist aktuell nicht erreichbar und muss gestartet werden.\n\nBitte wenden Sie sich an ihren Support, um diese Instanz starten zu lassen.";
      } else {
        text = "The server [**" + server.hostname + "**](" + server.origin + ") is currently unreachable and needs to be started.\n\nPlease contact your support to have this instance started.";
      }
    }
    if (language === "de") {
      buttonTextOk = "Nochmal probieren";
    } else {
      buttonTextOk = "Try again";
    }
    ez5.session.loadTheme().always((function(_this) {
      return function() {
        return CUI.problem({
          text: text,
          button_text_ok: buttonTextOk,
          markdown: true
        }).done(function() {
          return document.location.reload();
        });
      };
    })(this));
  };

  Start.prototype.getLogo = function() {
    if (!this.__logoImg) {
      this.__logoDiv = CUI.dom.div("ez-config-logo");
      return this.updateLogo();
    } else {
      return this.__logoDiv;
    }
  };

  Start.prototype.updateLogo = function() {
    var asset, linkElement, logo, logoUrl, ref, version;
    logo = CUI.dom.div("ez-logo");
    CUI.dom.empty(this.__logoDiv);
    CUI.dom.append(this.__logoDiv, logo);
    this.__logoImg = ez5.session.getConfigPicture("logo");
    if (this.__logoImg) {
      asset = new AssetPlain({
        value: this.__logoImg
      });
      version = Asset.getBestImageForViewport(asset, 200, 200);
      if (version) {
        logoUrl = (ref = ez5.session.getBaseConfig().logo) != null ? ref.external_url : void 0;
        if (!CUI.util.isEmpty(logoUrl)) {
          linkElement = CUI.dom.a(null, {
            href: logoUrl
          });
          CUI.dom.append(linkElement, asset.getImgElement(null, version.version));
          CUI.dom.append(logo, linkElement);
        } else {
          CUI.dom.append(logo, asset.getImgElement(null, version.version));
        }
      }
    }
    return this.__logoDiv;
  };

  Start.prototype.loadDefaults = function() {
    var dfr;
    console.timeLog("Start", "loadDefaults start");
    dfr = new CUI.Deferred();
    CUI.when(ez5.schema.load_schema().always((function(_this) {
      return function() {
        return console.timeLog("Start", "schema loaded");
      };
    })(this)), (ez5.groupManager = new GroupManager({
      auto_reload: true
    })).loadAllGroups().always((function(_this) {
      return function() {
        return console.timeLog("Start", "group manager loaded");
      };
    })(this)), (ez5.aclRights = new AclRights()).load().always((function(_this) {
      return function() {
        return console.timeLog("Start", "rights loaded");
      };
    })(this)), (ez5.metadata = new MetadataProfileList()).load().always((function(_this) {
      return function() {
        return console.timeLog("Start", "metadata loaded");
      };
    })(this)), (ez5.objecttypes = new Objecttypes()).load().always((function(_this) {
      return function() {
        return console.timeLog("Start", "objecttype rights loaded");
      };
    })(this)), (ez5.tagForm = new TagFormSimple()).load().always((function(_this) {
      return function() {
        return console.timeLog("Start", "tag form loaded");
      };
    })(this)), (ez5.pools = new PoolManagerList({
      auto_reload: true
    })).loadList().always((function(_this) {
      return function() {
        return console.timeLog("Start", "pools loaded");
      };
    })(this))).done((function(_this) {
      return function() {
        console.timeLog("Start", "loadDefaults done");
        RightPresetManager.init();
        ez5.objecttypes.init();
        console.timeLog("Start", "right presets initialized");
        return ez5.defaults_done().done(dfr.resolve).fail(dfr.reject);
      };
    })(this)).fail(dfr.reject);
    return dfr.promise();
  };

  Start.PF_HOST_REGEXP = /http(s)?:\/\/([^.]+)\.5\.easydb\.de$/;

  Start.prototype.__checkKnownServer = function() {
    var label, match, serverUrl;
    serverUrl = CUI.getSessionStorage("server");
    match = serverUrl.match(Start.PF_HOST_REGEXP);
    if (!match) {
      return;
    }
    label = new CUI.Label({
      text: serverUrl,
      markdown: true,
      "class": 'ez5-modebar ez5-modebar--known-server'
    });
    document.documentElement.classList.add('ez5--has-modebar');
    CUI.dom.append(document.body, label);
  };

  Start.prototype.checkBrowser = function() {
    var bw, dfr, e, unsupportedBrowserData, version;
    dfr = new CUI.Deferred();
    bw = window.bowser || {};
    version = "ez5-browser-" + ((bw.chrome || bw.vivaldi || bw.chromium) ? "chrome" : bw.msie ? "msie" : bw.safari ? "safari" : bw.firefox ? "firefox" : "other");
    document.body.classList.add(version);
    document.body.classList.add(version + "-" + parseInt(bw.version));
    try {
      window.localStorage;
      window.sessionStorage;
    } catch (error1) {
      e = error1;
      CUI.problem({
        text: $$("start.cookies_disabled.error"),
        button_text_ok: $$("start.cookies_disabled.button.reload")
      }).done((function(_this) {
        return function() {
          return document.location.reload();
        };
      })(this));
      return CUI.rejectedPromise();
    }
    if (false && ((bw.chrome && bw.version >= 54) || (bw.chromium && bw.version >= 54) || bw.vivaldi || bw.msedge || (bw.firefox && bw.version >= 49) || (bw.safari && bw.version >= "10.0") || (bw.iphone && bw.version >= "10.0") || (bw.ipad && bw.version >= "10.0"))) {
      if (ez5.session.getPref("browser_unsupported")) {
        ez5.session.setPref("browser_unsupported", null).saveCookiePrefs();
      }
      dfr.resolve();
    } else {
      CUI.problem({
        text: "Your browser is unspported",
        markdown: true
      }).done((function(_this) {
        return function() {
          return dfr.resolve();
        };
      })(this));
      unsupportedBrowserData = {
        userAgent: navigator.userAgent,
        bowser: bw
      };
      ez5.session.setPref("browser_unsupported", unsupportedBrowserData).saveCookiePrefs();
      console.warn($$("browser.unsupported"));
      console.warn("User Agent:", unsupportedBrowserData.userAgent);
      console.warn("Bowser:", JSON.stringify(unsupportedBrowserData.bowser));
    }
    return dfr.promise();
  };

  Start.getCSSUrl = function(name, mode) {
    var css_url;
    CUI.util.assert(indexOf.call(this.getCSSModes(), mode) >= 0, "Start.setCssMode", "Unknown or unavailable mode: " + mode);
    if (mode === "remote" && window.easydb_server_url) {
      css_url = window.easydb_server_url + "/web/css/ez5_" + name + ".css";
    } else {
      css_url = window.easydb_base_prefix + "/web/css/ez5_" + name + ".css";
    }
    return css_url;
  };

  Start.getCSSModes = function() {
    var modes;
    modes = [];
    modes.push("local");
    if (window.easydb_server_url) {
      modes.push("remote");
    }
    return modes;
  };

  Start.getSolutionCssPrefix = function() {
    var css_plugin, css_prefix, css_url, i, len, plugin, pn, ref;
    css_prefix = null;
    if (!ez5.pluginManager) {
      return null;
    }
    ref = ez5.pluginManager.getPluginNames();
    for (i = 0, len = ref.length; i < len; i++) {
      pn = ref[i];
      plugin = ez5.pluginManager.getPlugin(pn);
      if (plugin.getWebfrontend().css_prefix) {
        CUI.util.assert(!css_plugin, "Start.getSolutionCssPrefix", "You can only have css_prefix set in one plugin. Plugin " + pn + " sets a second.", {
          second_plugin: plugin,
          first_plugin: css_plugin
        });
        css_plugin = plugin;
      }
    }
    if (!css_plugin) {
      return null;
    }
    css_url = css_plugin.getBaseURL() + css_plugin.getWebfrontend().css_prefix;
    return css_url;
  };

  return Start;

})(CUI.Element);

CUI.ready(function() {
  console.timeLog("Start", "cui ready");
  ez5.start = new Start();
  return ez5.start.main();
});
